#ifndef _Data_h
#define _Data_h

#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>
#include <string>

class Data {
public:
    Data(std::string _filename) {
        std::fstream file(_filename.c_str(), std::ios::in);

        if (file) {
            double a, b;
            std::string line;
            while (std::getline(file, line)) {
                std::istringstream iss(line);
                iss >> a;
                y.push_back(a);

                std::vector<double> xi;
                while (iss >> b) {
                    xi.push_back(b);
                }
                x.push_back(xi);
            }

            file.close();
        } else {
            std::cerr << "Impossible to open " << _filename << std::endl;
        }
    }

    void meanX(std::vector<double> & mu) {
        mu.resize(x[0].size());
        for(unsigned j = 0; j < mu.size(); j++)
            mu[j] = 0;

        for(unsigned i = 0; i < x.size(); i++)
            for(unsigned j = 0; j < mu.size(); j++)
                mu[j] += x[i][j];

        for(unsigned j = 0; j < mu.size(); j++)
            mu[j] /= x.size();        
    }

    double meanY() {
        double mu = 0;

        for(unsigned i = 0; i < x.size(); i++)
            mu += y[i];

        return mu / y.size();  
    }

    void printOn(std::ostream & _out) {
        for(unsigned i = 0; i < y.size(); i++) {
            _out << y[i] ;
            for(unsigned j = 0; j < x[i].size(); j++) 
                _out << " " << x[i][j];
            _out << std::endl;
        }
    }

    // predictors
    std::vector< std::vector<double> > x;

    // reponse
    std::vector<double> y;

};

#endif